﻿using System;
using System.Threading;
using NationalInstruments.NI4882;

namespace CSharp_GPIB_chamber_io_non_visa
{
  class Program
  {
    static private Device device;

    static void Main(string[] args)
    {
      int nGpibBoardId = 0;
      byte byteChamberControllerGpibDeviceAddress = 10;
      byte byteGpibSecondaryAddress = 0;

      device = new Device(nGpibBoardId, byteChamberControllerGpibDeviceAddress, byteGpibSecondaryAddress);

      device.Write("*idn?\r");
      string strValue = device.ReadString();
      Console.WriteLine("Value read from chamber controller=" + strValue);

      // Note:  ALWAYS read after a write even if not needing a return value
      device.Write("RUNM\r"); // run manual
      strValue = device.ReadString();
      Console.WriteLine("Put chamber in Run Manual mode");

      for (int nLoop = 0; nLoop < 10; nLoop++)
      {
        Thread.Sleep(1000);
        device.Write("SETP1," + (nLoop + 25) + "\r");
        strValue = device.ReadString();
        Console.WriteLine("Write new setpoint =" + (nLoop + 25));

        device.Write("PVAR1?\r");
        strValue = device.ReadString();
        Console.WriteLine("Process variable 1 (temperature) =" + strValue);

        device.Write("SETP1?\r");
        strValue = device.ReadString();
        Console.WriteLine("Temperature Setpoint =" + strValue);
      }

      // Note:  ALWAYS read after a write even if not needing a return value
      device.Write("STOP\r"); // stop the chamber
      strValue = device.ReadString();
      Console.WriteLine("Chamber stopped");

      Console.WriteLine("Press any key...");
      Console.ReadKey();

      device.Dispose();
    }
  }
}
